# uobject.h File Reference

C++ API: Common ICU base class UObject. More...

`#include "unicode/utypes.h"`

Go to the source code of this file.

## Data Structures
class | UMemory
| UMemory is the common ICU base class. More...
class | UObject
| UObject is the common ICU "boilerplate" class. More...
## Defines
#define | U_HAVE_DEBUG_LOCATION_NEW 0
| Define this to define the MFC debug version of the operator new.
#define | UOBJECT_DEFINE_RTTI_IMPLEMENTATION(myClass)
| This is a simple macro to add ICU RTTI to an ICU object implementation.
#define | UOBJECT_DEFINE_ABSTRACT_RTTI_IMPLEMENTATION(myClass)
| This macro adds ICU RTTI to an ICU abstract class implementation.

## Detailed Description

C++ API: Common ICU base class UObject.

Definition in file uobject.h.

## Define Documentation

#define U_HAVE_DEBUG_LOCATION_NEW 0

Define this to define the MFC debug version of the operator new.

Stable:
  ICU 3.4

Definition at line 63 of file uobject.h.

#define UOBJECT_DEFINE_ABSTRACT_RTTI_IMPLEMENTATION | ( | myClass |  | ) |

Value:

    UClassID U_EXPORT2 myClass::getStaticClassID() { \
            static char classID = 0; \
            return (UClassID)&classID; \
        }

This macro adds ICU RTTI to an ICU abstract class implementation.

This macro should be invoked in *.cpp files. The corresponding header should declare getStaticClassID.

Parameters:

  | myClass | The name of the class that needs RTTI defined.

Internal:
  Do not use. This API is for internal use only.

Definition at line 314 of file uobject.h.

#define UOBJECT_DEFINE_RTTI_IMPLEMENTATION | ( | myClass |  | ) |

Value:

    UClassID U_EXPORT2 myClass::getStaticClassID() { \
            static char classID = 0; \
            return (UClassID)&classID; \
        } \
        UClassID myClass::getDynamicClassID() const \
        { return myClass::getStaticClassID(); }

This is a simple macro to add ICU RTTI to an ICU object implementation.

This does not go into the header. This should only be used in *.cpp files.

Parameters:

  | myClass | The name of the class that needs RTTI defined.

Internal:
  Do not use. This API is for internal use only.

Definition at line 297 of file uobject.h.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Defines